import React from 'react';
import ButtonGroup from '../ButtonGroup';
import OverflowMenuItem from '../OverflowMenuItem';
import Button from '../Button';
import { mount } from 'enzyme';
describe('ButtonGroup', function () {
  describe('renders as expected', function () {
    var wrapper = mount( /*#__PURE__*/React.createElement(ButtonGroup, {
      buttonLabel: 'Button Label'
    }, /*#__PURE__*/React.createElement(OverflowMenuItem, {
      itemText: 'Item 1'
    }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
      itemText: 'Item 2'
    }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
      itemText: 'Item 2'
    })));
    it('displays the correct menu text', function () {
      expect(wrapper.find(Button).props().children).toEqual('Button Label');
    });
    it('renders all children as expected', function () {
      var menu = wrapper.find(Button);
      menu.simulate('click');
      expect(wrapper.find('FloatingMenu ul').props().children.length).toEqual(3);
    });
  });
});