function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import PropTypes from 'prop-types';
import React, { useEffect, useState, useRef } from 'react';
import TooltipDefiniton from '../TooltipDefinition';
import { settings } from '@rocketsoftware/carbon-components';
var prefix = settings.prefix;

var CardContentItem = function CardContentItem(_ref) {
  var info = _ref.info,
      cardContentRef = _ref.cardContentRef,
      maxWidth = _ref.maxWidth;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      overflowState = _useState2[0],
      setOverflowState = _useState2[1];

  var contentRef = useRef(null);
  useEffect(function () {
    if (cardContentRef !== undefined) {
      setOverflowState(contentRef.current.clientWidth > cardContentRef.current.clientWidth);
    }
  }, [cardContentRef]);
  return /*#__PURE__*/React.createElement("div", {
    ref: contentRef
  }, !overflowState && /*#__PURE__*/React.createElement("h4", {
    style: {
      whiteSpace: 'nowrap'
    },
    className: "".concat(prefix, "--about__title--additional-info")
  }, info), overflowState && /*#__PURE__*/React.createElement(TooltipDefiniton, {
    assistiveTextClassName: "".concat(prefix, "--assistive-text__overflow"),
    triggerClassName: "".concat(prefix, "--card-text__overflow"),
    direction: 'middle',
    tooltipText: info
  }, /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefix, "--definition-text__span"),
    style: {
      maxWidth: maxWidth
    }
  }, info)));
};

CardContentItem.propTypes = {
  /**
   * String of information to be shown on a card
   */
  info: PropTypes.string,

  /**
   * Prop for ref which is passed to it by the CardContent component
   */
  cardContentRef: PropTypes.oneOfType([PropTypes.func, PropTypes.shape({
    current: PropTypes.any
  })]),

  /**
   * Specify max-width of item (should be no bigger than the intended width of card)
   */
  maxWidth: PropTypes.string
};
export default CardContentItem;