function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import React from 'react';
import { action } from '@storybook/addon-actions';
import Button from '../../Button';
import DataTable, { Table, TableBody, TableCell, TableContainer, TableHead, TableHeader, TableRow, TableToolbar, TableToolbarAction, TableToolbarContent, TableToolbarSearch, TableToolbarMenu, TableSelectAll, TableSelectRow } from '..';
import { initialRowsLarge, headers } from './shared'; // eslint-disable-next-line react/display-name

export default (function (props) {
  return /*#__PURE__*/React.createElement(DataTable, _extends({
    rows: initialRowsLarge,
    headers: headers
  }, props, {
    render: function render(_ref) {
      var rows = _ref.rows,
          headers = _ref.headers,
          getHeaderProps = _ref.getHeaderProps,
          getRowProps = _ref.getRowProps,
          getSelectionProps = _ref.getSelectionProps,
          getTableProps = _ref.getTableProps,
          onInputChange = _ref.onInputChange;
      return /*#__PURE__*/React.createElement(TableContainer, {
        title: "DataTable",
        description: "With toolbar"
      }, /*#__PURE__*/React.createElement(TableToolbar, null, /*#__PURE__*/React.createElement(TableToolbarContent, null, /*#__PURE__*/React.createElement(TableToolbarSearch, {
        onChange: onInputChange
      }), /*#__PURE__*/React.createElement(TableToolbarMenu, null, /*#__PURE__*/React.createElement(TableToolbarAction, {
        onClick: action('Action 1 Click')
      }, "Action 1"), /*#__PURE__*/React.createElement(TableToolbarAction, {
        onClick: action('Action 2 Click')
      }, "Action 2"), /*#__PURE__*/React.createElement(TableToolbarAction, {
        onClick: action('Action 3 Click')
      }, "Action 3")), /*#__PURE__*/React.createElement(Button, {
        onClick: action('ButtonCLick')
      }, "Primary Button"))), /*#__PURE__*/React.createElement(Table, getTableProps(), /*#__PURE__*/React.createElement(TableHead, null, /*#__PURE__*/React.createElement(TableRow, null, /*#__PURE__*/React.createElement(TableSelectAll, getSelectionProps()), headers.map(function (header) {
        return (
          /*#__PURE__*/
          // eslint-disable-next-line react/jsx-key
          React.createElement(TableHeader, getHeaderProps({
            header: header
          }), header.header)
        );
      }))), /*#__PURE__*/React.createElement(TableBody, null, rows.map(function (row) {
        return (
          /*#__PURE__*/
          // eslint-disable-next-line react/jsx-key
          React.createElement(TableRow, getRowProps({
            row: row
          }), /*#__PURE__*/React.createElement(TableSelectRow, getSelectionProps({
            row: row
          })), row.cells.map(function (cell) {
            return (
              /*#__PURE__*/
              // eslint-disable-next-line react/jsx-key
              React.createElement(TableCell, {
                key: cell.id
              }, cell.value)
            );
          }))
        );
      }))));
    }
  }));
});