function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import PropTypes from 'prop-types';
import React from 'react';
import cx from 'classnames';
import { settings } from '@rocketsoftware/carbon-components';
var prefix = settings.prefix;

var FooterWrapper = function FooterWrapper(_ref) {
  var _cx;

  var children = _ref.children,
      className = _ref.className,
      inZowe = _ref.inZowe,
      id = _ref.id;
  var wrapperClasses = cx((_cx = {}, _defineProperty(_cx, "".concat(prefix, "--footer-wrapper"), true), _defineProperty(_cx, "in-zowe", inZowe), _defineProperty(_cx, className, className), _cx));
  return /*#__PURE__*/React.createElement("div", {
    className: wrapperClasses,
    id: id
  }, children);
};

FooterWrapper.propTypes = {
  /**
   * Specify an id for the wrapper
   */
  id: PropTypes.string,

  /**
   * Provide nodes to be rendered within the wrapper
   */
  children: PropTypes.node,

  /**
   * Provide an optional class to be added to the wrapper
   */
  className: PropTypes.string,

  /**
   * Specify whether the footer will be used in Zowe
   */
  inZowe: PropTypes.bool
};
FooterWrapper.defaultProps = {
  inZowe: true
};
export default FooterWrapper;