"use strict";

var _react = _interopRequireDefault(require("react"));

var _Tour = _interopRequireDefault(require("../Tour"));

var _TourTooltip = _interopRequireDefault(require("../TourTooltip"));

var _enzyme = require("enzyme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var description = 'Tooltip description for a tour step.';
var steps = {
  default: function _default() {
    return [{
      selector: null,
      description: description
    }];
  }
};
describe('Tour', function () {
  describe('renders as expected', function () {
    var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_Tour.default, {
      steps: steps.default()
    }));
    it('renders the tooltip', function () {
      expect(wrapper.find(_TourTooltip.default).length).toEqual(1);
    });
    it('passes content to tooltip through steps', function () {
      var descRegExp = new RegExp(description);
      expect(descRegExp.test(wrapper.text())).toEqual(true);
    });
  });
});