"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _walktour = require("@rocketsoftware/walktour");

var _TourTooltip = _interopRequireDefault(require("../TourTooltip"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Tour = /*#__PURE__*/function (_React$Component) {
  _inherits(Tour, _React$Component);

  var _super = _createSuper(Tour);

  function Tour(props) {
    var _this;

    _classCallCheck(this, Tour);

    _this = _super.call(this, props);
    _this.state = {
      flipped: false
    };
    return _this;
  }

  _createClass(Tour, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          flippedTitle = _this$props.flippedTitle,
          flippedDescription = _this$props.flippedDescription,
          enableFlip = _this$props.enableFlip,
          flipBeforeCloseProp = _this$props.flipBeforeClose;
      return /*#__PURE__*/_react.default.createElement(_walktour.Walktour, _extends({}, this.props, {
        customCloseFunc: function customCloseFunc(logic) {
          if (_this2.props.onClose) {
            _this2.props.onClose(logic.stepIndex);
          }

          logic.close();
        },
        customTooltipRenderer: function customTooltipRenderer(logic) {
          var _logic$stepContent = logic.stepContent,
              title = _logic$stepContent.title,
              description = _logic$stepContent.description,
              disableNext = _logic$stepContent.disableNext,
              disablePrev = _logic$stepContent.disablePrev,
              hideNext = _logic$stepContent.hideNext,
              hidePrev = _logic$stepContent.hidePrev,
              hideClose = _logic$stepContent.hideClose,
              nextLabel = _logic$stepContent.nextLabel,
              prevLabel = _logic$stepContent.prevLabel,
              flipBeforeClose = _logic$stepContent.flipBeforeClose;
          return /*#__PURE__*/_react.default.createElement(_TourTooltip.default, _extends({}, enableFlip && {
            enableFlip: true,
            flipped: _this2.state.flipped,
            onFlip: function onFlip() {
              return _this2.setState({
                flipped: !_this2.state.flipped
              });
            }
          }, {
            flippedTitle: flippedTitle,
            flippedDescription: flippedDescription
          }, _this2.props, {
            flipBeforeClose: flipBeforeClose || flipBeforeCloseProp,
            onNext: logic.next,
            onPrev: logic.prev,
            onClose: logic.close,
            description: description,
            title: title,
            disableNext: disableNext,
            disablePrev: disablePrev,
            hideNext: hideNext,
            hidePrev: hidePrev,
            hideClose: hideClose,
            nextLabel: nextLabel,
            prevLabel: prevLabel
          }));
        }
      }));
    }
  }]);

  return Tour;
}(_react.default.Component);

exports.default = Tour;
Tour.propTypes = {
  /**
   * An array of steps that the tour should follow
   */
  steps: _propTypes.default.arrayOf(_propTypes.default.shape({
    selector: _propTypes.default.string,
    description: _propTypes.default.string.isRequired,
    title: _propTypes.default.string,
    nextLabel: _propTypes.default.string,
    prevLabel: _propTypes.default.string,
    disableNext: _propTypes.default.bool,
    disablePrev: _propTypes.default.bool,
    hideNext: _propTypes.default.bool,
    hidePrev: _propTypes.default.bool,
    hideClose: _propTypes.default.bool,
    customNextFunc: _propTypes.default.func,
    customPrevFunc: _propTypes.default.func,
    disableAutoScroll: _propTypes.default.bool,
    disableSmoothScroll: _propTypes.default.bool,
    movingTarget: _propTypes.default.bool,
    maskPadding: _propTypes.default.number,
    tooltipSeparation: _propTypes.default.number,

    /**
     * Optionally cause the tour to advance to the next step upon clicking the targeted element.
     * Only buttons are supported.
     */
    nextOnTargetClick: _propTypes.default.bool,

    /**
     * Validate before advancing the tour after clicking a button. Expects a promise resolving to a boolean.
     */
    validateNextOnTargetClick: _propTypes.default.func,
    orientationPreferences: _propTypes.default.oneOf(['east', 'east-north', 'east-south', 'south', 'south-east', 'south-west', 'west', 'west-north', 'west-south', 'north', 'north-east', 'north-west']),

    /**
     * If specified, the tour will try to target and position with respect to an element that is outside
     * of its parent container. The tour is still bound to its container, so this should only be used
     * sparingly in situations where it cannot be avoided.
     */
    allowForeignTarget: _propTypes.default.bool
  })).isRequired,

  /** Optionally specify a custom close function for the entire tour. Passed the current step index as a param.
   */
  onClose: _propTypes.default.func,

  /**
   * Optionally specify the starting step. If conditionally rendering ({showTour && <Tour... />})
   * this can be used to resume from a particular step, even after unmounting.
   */
  initialStepIndex: _propTypes.default.number,

  /**
   * Optionally specify whether the tour should update upon changes to the target's size or position.
   */
  movingTarget: _propTypes.default.bool,

  /**
   * Optional identifier to differentiate between multiple tours on the same page.
   */
  identifier: _propTypes.default.string,

  /**
   * Optionally specify whether the mask should be disabled
   */
  disableMask: _propTypes.default.bool,

  /**
   * Optionally disable automatic scrolling
   */
  disableAutoScroll: _propTypes.default.bool,

  /**
   * Optionally disable smooth scrolling
   */
  disableSmoothScroll: _propTypes.default.bool,

  /**
   * Optionally disables closing the tour on mask click
   */
  disableCloseOnClick: _propTypes.default.bool,

  /**
   * Optionally provide a callback that handles receiving an update function. Can be used to listen
   * for events and recalculate the tour's position when those events fire. The callback will be
   * passed `update` as an argument.
   */
  setUpdateListener: _propTypes.default.func,

  /**
   * Optionally provide a callback intended to remove the listener set by `setUpdateListener`.
   * The callback will be passed `update` as an argument. Should only and always be used with `setUpdateListener`.
   */
  removeUpdateListener: _propTypes.default.func,

  /**
   * Optionally specify whether the tour is active or not. If specified, the tour will act as
   * a controlled component, and will defer to this prop when closing.
   */
  isOpen: _propTypes.default.bool,

  /**
   * Optionally specify whether the "next"" button should be hidden
   */
  hideNext: _propTypes.default.bool,

  /**
   * Optionally specify whether the "previous" button should be hidden
   */
  hidePrev: _propTypes.default.bool,

  /**
   * Optionally allow the tooltip to be flipped over, exposing secondary content on the back side.
   */
  enableFlip: _propTypes.default.bool,

  /**
   * Secondary Title, visible when the tooltip is flipped. Access flip functionality with "enableFlip"
   */
  flippedTitle: _propTypes.default.string,

  /**
   * Secondary body content, visible when the tooltip is flipped. Access flip functionality with "enableFlip"
   */
  flippedDescription: _propTypes.default.string,

  /**
   * Supports an alternative use case for the flipped case where it will first flip to that face and then close
   * on second click.
   */
  flipBeforeClose: _propTypes.default.bool,

  /**
   * Accessibility label text for the "close" button
   */
  closeButtonAriaLabel: _propTypes.default.string,

  /**
   * Accessibility label text for the "flip" button
   */
  flipButtonAriaLabel: _propTypes.default.string,

  /**
   * Optional selector to explicitly define where the tour components should be rendered in the DOM.
   * This impacts scrolling/scoping, and should only be used if absolutely necessary.
   */
  rootSelector: _propTypes.default.string
};